//TIMES header
/**
 * Transition information (TIMES code)
 */
typedef struct s_TransitionType trans_t;

/**
 * Location list type (TIMES code)
 */
typedef int loc_t;

/**
 * Define bool type (TIMES code)
 */
typedef int bool;

/**
 * @name Task identifiers (tid).//TIMES code
 */
#ifndef tid_offset
#define tid_offset 200
#endif /* tid_offset */

//TIMES code
#define QUEUE_BOUND 3
#define NB_TASK 0
#define NB_TRANS 107
#define NB_PROC 1
#define NB_LOC 49
#define NB_CLOCKS 1

const char* cl0 = "GPCA_Instance_clk_x1";
const char** CLOCKNAMES[NB_CLOCKS] = {&cl0};

const char* iv0= "E_RequestBolus";
const char* iv1= "E_StopInfusion";
const char* iv2= "E_PauseInfusion";
const char* iv3= "E_ConfirmPauseInfusion";
const char* iv4= "E_ClearAlarm";
const char* iv5= "E_Cancel";
const char* iv6= "E_ChangeDoseRate";
const char* iv7= "T_Cond_6_6";
const char* iv8= "T_Cond_6_3";
const char* iv9= "T_Cond_6_4";
const char* iv10= "T_Cond_6_5";
const char* iv11= "E_ConfirmStopInfusion";
const char* iv12= "E_ConfirmDoseRate";
const char* iv13= "E_NewInfusion";
const char* iv14= "Level_Two_Alarm";
const char* iv15= "MCond_6_6";
const char* iv16= "TCond_6_3";
const char* iv17= "Cond_6_3";
const char* iv18= "TCond_6_5";
const char* iv19= "TCond_6_4";
const char* iv20= "Cond_7_4";
const char* iv21= "Cond_7_3";
const char* iv22= "Cond_2";
const char* iv23= "E_ConfigureInfusionProgram";
const char* iv24= "E_ChangeVTBI";
const char* iv25= "E_ConfirmVTBI";
const char* iv26= "Cond_4_1";
const char* iv27= "Cond_4_2";
const char* iv28= "Cond_4_3";
const char* iv29= "Cond_4_4";
const char* iv30= "Cond_4_5";
const char* iv31= "Cond_4_6";
const char* iv32= "Cond_5_1";
const char* iv33= "E_StartInfusion";
const char* iv34= "MCDR_In_Progress";
const char* iv35= "E_CheckAdminSet";
const char* iv36= "E_CheckAdminSet_1";
const char* iv37= "Cond_3_1";
const char* iv38= "Cond_3_2";
const char* iv39= "Cond_3_3";
const char* iv40= "Cond_3_4";
const char* iv41= "E_CheckDrug";
const char* iv42= "Cond_3_5";
const char* iv43= "Cond_3_6";
const char* iv44= "Cond_3_7";
const char* iv45= "Cond_3_8";
const char* iv46= "Cond_3_9";
const char* iv47= "Cond_3_11";
const char* iv48= "Cond_3_10";
const char* iv49= "E_ConfirmConcentration";
const char* iv50= "E_Prime";
const char* iv51= "E_PowerButton";
const char* iv52= "Power_ON";
const char* iv53= "MCond_1_3";
const char* iv54= "MCond_1_4";
const char* iv55= "Cond_5_2";
const char* iv56= "Cond_6_2";
const char* iv57= "Cond_7_1";
const char* iv58= "Cond_7_2";
#define NB_VAR 59
const char** VARNAMES[NB_VAR] = {&iv0,&iv1,&iv2,&iv3,&iv4,&iv5,&iv6,&iv7,&iv8,&iv9,&iv10,&iv11,&iv12,&iv13,&iv14,&iv15,&iv16,&iv17,&iv18,&iv19,&iv20,&iv21,&iv22,&iv23,&iv24,&iv25,&iv26,&iv27,&iv28,&iv29,&iv30,&iv31,&iv32,&iv33,&iv34,&iv35,&iv36,&iv37,&iv38,&iv39,&iv40,&iv41,&iv42,&iv43,&iv44,&iv45,&iv46,&iv47,&iv48,&iv49,&iv50,&iv51,&iv52,&iv53,&iv54,&iv55,&iv56,&iv57,&iv58};

/**
 * Transition table element (TIMES code)
 */
//struct s_TransitionType {
//  char active;      /**< Active transition */
//  char from;        /**< Source location */
//  char to;          /**< Target location id */
//  signed char sync; /**< Syncronisation id */
//};
struct s_TransitionType {
  int active;      /**< Active transition */
  int from;        /**< Source location */
  int to;          /**< Target location id */
  int sync; /**< Syncronisation id */
};

//TIMES code
#ifndef true
#define true (1==1)
#endif

#ifndef false
#define false (0==1)
#endif

/**
 * @name Task identifiers (tid).
 */
#define tid_offset 200
#define tid_NOP tid_offset+0


/**
 * Location identifiers, also offsets into
 * location array.
 */
#define GPCA_Instance_Infusion_NormalOperation 0
#define GPCA_Instance_ConfirmPause 9
#define GPCA_Instance_InfusionPaused 14
#define GPCA_Instance_Alrm_TooLongInfusionPause 18
#define GPCA_Instance_InfusionStopped 22
#define GPCA_Instance_ConfirmStop 25
#define GPCA_Instance_Alrm_LevelTwoHardwareFailure 30
#define GPCA_Instance_Wrn_LowReservior 34
#define GPCA_Instance_Alrm_EmptyReservior 36
#define GPCA_Instance_CheckDrug 39
#define GPCA_Instance_Alrm_WrongDrug 43
#define GPCA_Instance_ChangeRate 46
#define GPCA_Instance_CheckNewRate 52
#define GPCA_Instance_Alrm_UnsafeNewRate 55
#define GPCA_Instance_DisplayVTBI 60
#define GPCA_Instance_ChangeVTBI 63
#define GPCA_Instance_Alrm_LongWait_ChangeVTBI 67
#define GPCA_Instance_CheckVTBI 69
#define GPCA_Instance_Alrm_VTBIHardLimitsViolation 73
#define GPCA_Instance_Wrn_VTBISoftLimitsViolation 75
#define GPCA_Instance_DisplayDoseRate 78
#define GPCA_Instance_ChangeDoseRate 81
#define GPCA_Instance_Alrm_LongWait_ChangeDoseRate 85
#define GPCA_Instance_CheckDoseRate 87
#define GPCA_Instance_Alarming_DoseRate_OutOfBound 91
#define GPCA_Instance_Wrn_DoseRateSoftLimitsViolation 93
#define GPCA_Instance_DisplaySetting 96
#define GPCA_Instance_Alrm_LongWait_StartInfusion 99
#define GPCA_Instance_ReadyToStart 101
#define GPCA_Instance_DisplayPatientProfile 104
#define GPCA_Instance_CDR_Init 107
#define GPCA_Instance_CheckAdministrationSet 109
#define GPCA_Instance_Alrm_IncorrectAdministrationSetup 112
#define GPCA_Instance_CheckPrime 114
#define GPCA_Instance_Alrm_PrimeFailure 117
#define GPCA_Instance_DisplayDrugInfo 119
#define GPCA_Instance_CheckDrugType 121
#define GPCA_Instance_Alrm_UnknownDrug 124
#define GPCA_Instance_CheckDoseUnit 126
#define GPCA_Instance_Alrm_DoseUnitMismatch 129
#define GPCA_Instance_CheckConcentration 131
#define GPCA_Instance_Wrn_ConcentrationSoftLimitsViolation 135
#define GPCA_Instance_Alrm_ConcentrationHardLimitsViolation 138
#define GPCA_Instance_POST_Init 140
#define GPCA_Instance_Post_In_Progress 142
#define GPCA_Instance_Alrm_POSTFailure 146
#define GPCA_Instance_PausedStopConfirm 148
#define GPCA_Instance_Alrm_LongWait_ChangeDoseRate_ISSM 151
#define GPCA_Instance_BolusRequest 153

/**
 * Constant values
 */
#define MAX_PAUSED_T 5
#define MAX_ALRM_T 10
#define MAX_CHECK_DRUG_T 5
#define MAX_WAIT_INPUT_T 5
#define MAX_POST_WAIT 10

//GLUE CODE
typedef long time_t;
#define MAX_CLOCK_VALUE 50000	//Max clock value
